diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.c freeciv-patched/common/unittype.c
--- freeciv-cvs/common/unittype.c	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/unittype.c	2003-07-07 18:21:49.000000000 +0100
@@ -22,8 +22,11 @@
 #include "fcintl.h"
 #include "game.h"
 #include "government.h"
+#include "log.h"
 #include "mem.h"
+#include "modifier.h"
 #include "player.h"
+#include "script.h"
 #include "shared.h"
 #include "support.h"
 #include "tech.h"
@@ -31,6 +34,8 @@
 #include "unittype.h"
 
 struct unit_type unit_types[U_LAST];
+struct modifier_type unit_modifier_types[MAX_MODS];
+struct modifier *unit_modifiers = NULL;
 /* the unit_types array is now setup in:
    server/ruleset.c (for the server)
    client/packhand.c (for the client)
@@ -52,7 +57,7 @@
   "DefendOk", "DefendGood", "AttackFast", "AttackStrong",
   "Ferryboat", "Barbarian", "BarbarianTech", "BarbarianBoat",
   "BarbarianBuild", "BarbarianBuildTech", "BarbarianLeader",
-  "BarbarianSea", "BarbarianSeaTech"
+  "BarbarianSea", "BarbarianSeaTech", "CanModify"
 };
 
 /**************************************************************************
@@ -379,6 +384,27 @@
 }
 
 /**************************************************************************
+  Returns the unit type which is built from the given base type and unit
+  modifiers, or U_LAST if none match.
+**************************************************************************/
+Unit_Type_id find_unit_type_by_modifiers(Unit_Type_id basetype, int *modifiers)
+{
+  unit_type_iterate(uid) {
+    int i;
+    if (unit_types[uid].basetype == basetype) {
+      for (i = 0; i < game.num_unit_modifier_types; ++i) {
+	if (unit_types[uid].modifiers[i] != modifiers[i]) {
+	  break;
+	} else if (i == game.num_unit_modifier_types - 1) {
+	  return uid;
+	}
+      }
+    }
+  } unit_type_iterate_end;
+  return U_LAST;
+}
+
+/**************************************************************************
   Convert unit_move_type names to enum; case insensitive;
   returns 0 if can't match.
 **************************************************************************/
@@ -449,17 +475,31 @@
 **************************************************************************/
 bool can_player_build_unit_direct(struct player *p, Unit_Type_id id)
 {
+  struct unit_type *u;
   Impr_Type_id impr_req;
   Tech_Type_id tech_req;
 
   if (!unit_type_exists(id))
     return FALSE;
+  u = &unit_types[id];
   if (unit_type_flag(id, F_FANATIC)
       && !government_has_flag(get_gov_pplayer(p), G_FANATIC_TROOPS))
     return FALSE;
-  if (get_invention(p,unit_types[id].tech_requirement)!=TECH_KNOWN)
+  if (get_invention(p, u->tech_requirement) != TECH_KNOWN)
     return FALSE;
 
+  /* Check tech requirements of unit modifiers if applicable */
+  if (u->basetype != U_LAST) {
+    int i;
+    for (i = 0; i < game.num_unit_modifier_types; ++i) {
+      if (u->modifiers[i] < U_LAST
+	  && get_invention(p, unit_modifiers[u->modifiers[i]].tech_requirement)
+			   != TECH_KNOWN) {
+	return FALSE;
+      }
+    }
+  }
+
   /* If the unit has a building requirement, we check to see if the player
    * can build that building.  Note that individual cities may not have
    * that building, so they still may not be able to build the unit. */
@@ -643,6 +683,12 @@
 
   free(p->helptext);
   p->helptext = NULL;
+
+  free(p->action);
+  p->action = NULL;
+
+  free(p->final_action);
+  p->final_action = NULL;
 }
 
 /***************************************************************
@@ -654,3 +700,132 @@
     unit_type_free(i);
   } unit_type_iterate_end;
 }
+
+/**************************************************************************
+  Convert unit_modifier_type names to int; case insensitive;
+  returns -1 if can't match.
+**************************************************************************/
+int unit_modifier_type_from_str(const char *s)
+{
+  return modifier_type_from_str(s, unit_modifier_types,
+      				game.num_unit_modifier_types);
+}
+
+/**************************************************************************
+Does a linear search of unit_modifiers[].name
+Returns -1 if none match.
+**************************************************************************/
+int find_unit_modifier_by_name(const char *s)
+{
+  return find_modifier_by_name(s, unit_modifiers, game.num_unit_modifiers);
+}
+
+static void ensure_unique_unit_name(struct unit_type *utype)
+{
+  char *tmpname, *tmporig;
+  char newname[MAX_LEN_NAME];
+  int mark = 2;
+  int maxlen = sizeof(utype->name) - 10; /* To allow for longer translations */
+  int maxorig = sizeof(utype->name_orig) - 6;
+
+  assert(maxlen > 0 && maxorig > 0);
+  tmpname = mystrdup(utype->name);
+  tmporig = mystrdup(utype->name_orig);
+
+  /* Make sure that the suffix won't be truncated each time */
+  if (strlen(tmpname) > maxlen) {
+    tmpname[maxlen - 1] = '\0';
+  }
+  if (strlen(tmporig) > maxorig) {
+    tmporig[maxorig - 1] = '\0';
+  }
+
+  sz_strlcpy(newname, utype->name);
+  utype->name[0] = '\0'; /* Prevent this unittype from matching */
+  while (find_unit_type_by_name(newname) != U_LAST) {
+    my_snprintf(newname, sizeof(newname), _("%s Mk%d"), tmpname, mark);
+    my_snprintf(utype->name_orig, sizeof(utype->name_orig), "%s Mk%d",
+                tmporig, mark);
+    assert(mark < 100);
+    mark++;
+  };
+  sz_strlcpy(utype->name, newname);
+
+  free(tmpname);
+  free(tmporig);
+}
+
+/**************************************************************************
+  ...
+**************************************************************************/
+static void copy_unit_type(struct unit_type *dest, struct unit_type *src)
+{
+  memcpy(dest, src, sizeof(struct unit_type));
+  dest->effect = NULL;
+  append_effects(&dest->effect, src->effect);
+  dest->helptext = src->helptext ? mystrdup(src->helptext) : NULL;
+  dest->action = dest->final_action = NULL;
+}
+
+/**************************************************************************
+  ...
+**************************************************************************/
+Unit_Type_id form_compound_unit(const char *name,
+    				const Unit_Type_id basetype,
+				const int modifiers[MAX_MODS],
+				char *final_action)
+{
+  Unit_Type_id id;
+  struct unit_type *u, *base;
+  struct modifier *mod;
+  char buffer[200];
+  int i;
+
+  id = game.num_unit_types;
+  if (id >= U_LAST) {
+    freelog(LOG_FATAL, "form_compound_unit: out of unit types");
+    exit(EXIT_FAILURE);
+  }
+  game.num_unit_types++;
+  u = &unit_types[id];
+  base = &unit_types[basetype];
+  copy_unit_type(u, base);
+  u->basetype = basetype;
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    u->modifiers[i] = modifiers[i];
+  }
+  u->tech_requirement = A_NONE;
+  u->obsoleted_by = -1;
+  u->name_orig[0] = '\0';
+  my_snprintf(buffer, sizeof(buffer),
+	      "variable ut = get_unit_type(%d);", id);
+  script_execute(buffer);
+  script_execute(base->action);
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    if (u->modifiers[i] < U_LAST) {
+      mod = &unit_modifiers[u->modifiers[i]];
+      script_execute(mod->action);
+    }
+  }
+  for (i = 0; i < game.num_unit_modifier_types; ++i) {
+    if (u->modifiers[i] < U_LAST) {
+      mod = &unit_modifiers[u->modifiers[i]];
+      script_execute(mod->final_action);
+      append_effects(&u->effect, mod->effect);
+    }
+  }
+  script_execute(base->final_action);
+  if (final_action) {
+    script_execute(final_action);
+  }
+  my_snprintf(buffer, sizeof(buffer),
+	      "set_unit_type(%d, ut);", id);
+  script_execute(buffer);
+  /* Overwrite the auto-generated name if a name is supplied */
+  if (name && name[0]) {
+    sz_strlcpy(u->name_orig, name);
+    sz_strlcpy(u->name, _(u->name_orig));
+  }
+  ensure_unique_unit_name(u);
+  return id;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/unittype.h freeciv-patched/common/unittype.h
--- freeciv-cvs/common/unittype.h	2003-07-07 18:20:26.000000000 +0100
+++ freeciv-patched/common/unittype.h	2003-07-07 18:21:49.000000000 +0100
@@ -14,6 +14,7 @@
 #define FC__UNITTYPE_H
 
 #include "shared.h"
+#include "modifier.h"
 
 struct player;
 struct city;
@@ -21,6 +22,9 @@
 struct Sprite;			/* opaque; client-gui specific */
 struct unit;
 struct impr_effect;
+struct section_file;
+struct memberdata;
+struct members;
 
 typedef int Unit_Type_id;
 /*
@@ -132,6 +136,7 @@
   L_BARBARIAN_LEADER,   /* barbarian leader */
   L_BARBARIAN_SEA,      /* sea raider unit */
   L_BARBARIAN_SEA_TECH, /* sea raider unit, global tech required */
+  L_CANMODIFY,          /* we can apply unit modifiers to this unit type */
   L_LAST
 };
 #define L_MAX 64
@@ -179,6 +184,10 @@
 
   struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
 
+  Unit_Type_id basetype;  /* if !U_LAST, unit modifiers are applied */
+  int modifiers[MAX_MODS];
+  char *action, *final_action;
+
   char *helptext;
 };
 
@@ -188,6 +197,8 @@
 };
 
 extern struct unit_type unit_types[U_LAST];
+extern struct modifier_type unit_modifier_types[MAX_MODS];
+extern struct modifier *unit_modifiers;
 
 bool unit_type_exists(Unit_Type_id id);
 struct unit_type *get_unit_type(Unit_Type_id id);
@@ -224,6 +235,7 @@
 
 Unit_Type_id find_unit_type_by_name(const char *s);
 
+Unit_Type_id find_unit_type_by_modifiers(Unit_Type_id basetype, int *modifiers);
 enum unit_move_type unit_move_type_from_str(const char *s);
 enum unit_flag_id unit_flag_from_str(const char *s);
 void unit_flag_set_name(enum unit_flag_id id, const char *s);
@@ -250,4 +262,11 @@
   }                                                                           \
 }
 
+int unit_modifier_type_from_str(const char *s);
+int find_unit_modifier_by_name(const char *s);
+
+Unit_Type_id form_compound_unit(const char *name,
+    				const Unit_Type_id basetype,
+				const int modifiers[MAX_MODS],
+				char *final_action);
 #endif  /* FC__UNITTYPE_H */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/Makefile.am freeciv-patched/server/Makefile.am
--- freeciv-cvs/server/Makefile.am	2003-06-07 19:58:48.000000000 +0100
+++ freeciv-patched/server/Makefile.am	2003-07-07 18:21:49.000000000 +0100
@@ -72,4 +72,4 @@
 
 
 civserver_DEPENDENCIES = ../common/libcivcommon.a ../ai/libcivai.a ./libcivserver.a ../common/aicore/libaicore.a
-civserver_LDADD        = ../common/libcivcommon.a ../ai/libcivai.a ./libcivserver.a @INTLLIBS@ ../common/libcivcommon.a ../ai/libcivai.a ./libcivserver.a ../common/aicore/libaicore.a $(SERVER_LIBS)
+civserver_LDADD        = ../common/libcivcommon.a ../ai/libcivai.a ./libcivserver.a @INTLLIBS@ ../common/libcivcommon.a ../ai/libcivai.a ./libcivserver.a ../common/aicore/libaicore.a $(SERVER_LIBS) -lslang-utf8
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/plrhand.c freeciv-patched/server/plrhand.c
--- freeciv-cvs/server/plrhand.c	2003-07-07 18:20:27.000000000 +0100
+++ freeciv-patched/server/plrhand.c	2003-07-07 18:21:49.000000000 +0100
@@ -38,6 +38,7 @@
 #include "gamehand.h"
 #include "gamelog.h"
 #include "maphand.h"
+#include "ruleset.h"
 #include "sernet.h"
 #include "settlers.h"
 #include "srv_main.h"
@@ -744,26 +745,16 @@
 /**************************************************************************
 ...
 **************************************************************************/
-void handle_player_government(struct player *pplayer,
-			     struct packet_player_request *preq)
+static void change_player_gov(struct player *pplayer, int newgov)
 {
-  if (pplayer->government != game.government_when_anarchy ||
-      preq->government < 0 || preq->government >= game.government_count ||
-      !can_change_to_government(pplayer, preq->government)) {
-    return;
-  }
-
-  if((pplayer->revolution<=5) && (pplayer->revolution>0))
-    return;
-
-  pplayer->government=preq->government;
+  pplayer->government = newgov;
   notify_player(pplayer, _("Game: %s now governs the %s as a %s."), 
 		pplayer->name, 
   	        get_nation_name_plural(pplayer->nation),
-		get_government_name(preq->government));  
+		get_government_name(newgov));  
   gamelog(GAMELOG_GOVERNMENT, _("%s form a %s"),
 	  get_nation_name_plural(pplayer->nation),
-	  get_government_name(preq->government));
+	  get_government_name(newgov));
 
   if (!pplayer->ai.control) {
     /* Keep luxuries if we have any.  Try to max out science. -GJW */
@@ -785,6 +776,24 @@
 /**************************************************************************
 ...
 **************************************************************************/
+void handle_player_government(struct player *pplayer,
+			     struct packet_player_request *preq)
+{
+  if (pplayer->government != game.government_when_anarchy ||
+      preq->government < 0 || preq->government >= game.government_count ||
+      !can_change_to_government(pplayer, preq->government)) {
+    return;
+  }
+
+  if((pplayer->revolution<=5) && (pplayer->revolution>0))
+    return;
+
+  change_player_gov(pplayer, preq->government);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 void handle_player_revolution(struct player *pplayer)
 {
   if ((pplayer->revolution<=5) &&
@@ -846,6 +855,26 @@
 }
 
 /**************************************************************************
+...
+**************************************************************************/
+void handle_request_compound(struct player *pplayer,
+			     struct packet_request_compound *req)
+{
+  if (req->is_gov) {
+    int id;
+
+    id = form_compound_gov(pplayer, req->name, req->basetype, req->modifiers);
+    send_single_government(&game.game_connections, id);
+    change_player_gov(pplayer, id);
+  } else {
+    Unit_Type_id id;
+
+    id = form_compound_unit(req->name, req->basetype, req->modifiers, NULL);
+    send_single_unit(&game.game_connections, id);
+  }
+}
+
+/**************************************************************************
   Handles a player cancelling a "pact" with another player.
 
   packet.id is id of player we want to cancel a pact with
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/plrhand.h freeciv-patched/server/plrhand.h
--- freeciv-cvs/server/plrhand.h	2003-06-07 19:58:49.000000000 +0100
+++ freeciv-patched/server/plrhand.h	2003-07-07 18:21:49.000000000 +0100
@@ -63,6 +63,8 @@
 			     struct packet_player_request *preq);
 void handle_player_research(struct player *pplayer,
 			    struct packet_player_request *preq);
+void handle_request_compound(struct player *pplayer,
+			     struct packet_request_compound *req);
 void handle_player_tech_goal(struct player *pplayer,
                             struct packet_player_request *preq);
 void handle_player_attribute_chunk(struct player *pplayer,
